com.io7m.jtensors.core.unparameterized.vectors

## Class Vectors2I

- java.lang.Object
- - com.io7m.jtensors.core.unparameterized.vectors.Vectors2I

-     public final class Vectors2I
      extends Object

  Functions over `Vector2I` values.

  See "Mathematics for 3D Game Programming and Computer Graphics" 2nd Ed for the derivations of most of the code in this class (ISBN: 1-58450-277-0).

  Since:
    8.0.0

- - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Vector2I` | `absolute(Vector2I v0)` Calculate the absolute of `v0`.
    `static Vector2I` | `add(Vector2I v0, Vector2I v1)` Add `v0` to `v1`.
    `static Vector2I` | `addScaled(Vector2I v0, Vector2I v1, double r)` Add `v0` to `v1 * r`.
    `static double` | `angle(Vector2I v0, Vector2I v1)` Calculate the angle between the vectors `v0` and `v1` in radians.
    `static Vector2I` | `clamp(Vector2I v, Vector2I v_min, Vector2I v_max)` Clamp the values in `v` by `v_min` and `v_max`.
    `static long` | `dotProduct(Vector2I v0, Vector2I v1)` Calculate the scalar product of the vectors `v0` and `v1`.
    `static Vector2I` | `interpolateLinear(Vector2I v0, Vector2I v1, double alpha)` Linearly interpolate between `v0` and `v1` by the amount `alpha`.
    `static double` | `magnitude(Vector2I v0)` Calculate the magnitude of the vector `v0`.
    `static long` | `magnitudeSquared(Vector2I v0)` Calculate the squared magnitude of the vector `v0`.
    `static Vector2I` | `negate(Vector2I v)` Calculate the negation of `v`.
    `static Vector2I` | `scale(Vector2I v0, double r)` Scale `v0` by `r`.
    `static Vector2I` | `subtract(Vector2I v0, Vector2I v1)` Subtract `v1` from `v0`.
    `static Vector2I` | `zero()` The zero vector.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### absolute

          public static Vector2I absolute(Vector2I v0)

      Calculate the absolute of `v0`.
      Returns:
        `(abs v0.x, abs v0.y)` * @param v0 The vector

    - #### add

          public static Vector2I add(Vector2I v0,
                                     Vector2I v1)

      Add `v0` to `v1`.
      Parameters:
        `v1` - The right vector
      Returns:
        `(v0.x + v1.x, v0.y + v0.y)` * @param v0 The left vector

    - #### addScaled

          public static Vector2I addScaled(Vector2I v0,
                                           Vector2I v1,
                                           double r)

      Add `v0` to `v1 * r`.
      Parameters:
        `v1` - The right vector
        `r` - The scaling value
      Returns:
        `(v0.x + (v1.x * r), v0.y + (v0.y * r))` * @param v0 The left vector

    - #### angle

          public static double angle(Vector2I v0,
                                     Vector2I v1)

      Calculate the angle between the vectors `v0` and `v1` in radians.
      Parameters:
        `v0` - The left input vector
        `v1` - The right input vector * @return The angle between the two vectors, in radians.

    - #### clamp

          public static Vector2I clamp(Vector2I v,
                                       Vector2I v_min,
                                       Vector2I v_max)

      Clamp the values in `v` by `v_min` and `v_max`.
      Parameters:
        `v_min` - The minimum vector
        `v_max` - The maximum vector
      Returns:
        `(max(min(v.x, v_max.x()), v_min.x()), max(min(v.y, v_max.y()), v_min.y()))` * @param v The source vector

    - #### dotProduct

          public static long dotProduct(Vector2I v0,
                                        Vector2I v1)

      Calculate the scalar product of the vectors `v0` and `v1`. * @param v0 The left vector
      Parameters:
        `v1` - The right vector
      Returns:
        The scalar product of the two vectors

    - #### interpolateLinear

          public static Vector2I interpolateLinear(Vector2I v0,
                                                   Vector2I v1,
                                                   double alpha)

      Linearly interpolate between `v0` and `v1` by the amount `alpha`.

      The `alpha` parameter controls the degree of interpolation, such that:

      - `interpolateLinear(v0, v1, 0.0) = v0`
      - `interpolateLinear(v0, v1, 1.0) = v1`
      Parameters:
        `v0` - The left input vector
        `v1` - The right input vector
        `alpha` - The interpolation value in the range `[0, 1]` * @return `((1 - alpha) * v0) + (alpha * v1)`

    - #### magnitudeSquared

          public static long magnitudeSquared(Vector2I v0)

      Calculate the squared magnitude of the vector `v0`. * @param v0 The vector
      Returns:
        The squared magnitude of the vector

    - #### magnitude

          public static double magnitude(Vector2I v0)

      Calculate the magnitude of the vector `v0`. * @param v0 The vector
      Returns:
        The magnitude of the vector

    - #### negate

          public static Vector2I negate(Vector2I v)

      Calculate the negation of `v`.
      Returns:
        `(-v.x, -v.y)` * @param v The vector

    - #### scale

          public static Vector2I scale(Vector2I v0,
                                       double r)

      Scale `v0` by `r`.
      Parameters:
        `r` - The scaling value
      Returns:
        `(v0.x * r, v0.y * r)` * @param v0 The left vector

    - #### subtract

          public static Vector2I subtract(Vector2I v0,
                                          Vector2I v1)

      Subtract `v1` from `v0`.
      Parameters:
        `v1` - The right vector
      Returns:
        `(v0.x - v1.x, v0.y - v0.y)` * @param v0 The left vector

    - #### zero

          public static Vector2I zero()

      The zero vector.
      Returns:
        `(0, 0)`

Copyright © 2017 <code@io7m.com> http://io7m.com